package TCPIP_Programming;

import org.apache.mina.core.service.IoHandlerAdapter;
import org.apache.mina.core.session.IdleStatus;
import org.apache.mina.core.session.IoSession;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class AnotherEchoProtocolHandler extends IoHandlerAdapter {
	    private final static Logger LOGGER = LoggerFactory.getLogger(EchoProtocolHandler.class);
	    
	    @Override
	    public void sessionCreated(IoSession session) {
	    	session.getConfig().setIdleTime(IdleStatus.BOTH_IDLE, 10);
	    }

	    @Override
	    public void sessionClosed(IoSession session) throws Exception {
	    	LOGGER.info("CLOSED");
	    }

	    @Override
	    public void sessionOpened(IoSession session) throws Exception {
	    	LOGGER.info("OPENED");
	    }

	    @Override
	    public void sessionIdle(IoSession session, IdleStatus status) {
	    	LOGGER.info("*** IDLE #" + session.getIdleCount(IdleStatus.BOTH_IDLE) + " ***");
	    }

	    @Override
	    public void exceptionCaught(IoSession session, Throwable cause) {
	    	session.close(true);
	    }

	    @Override
	    public void messageReceived(IoSession session, Object message)
	            throws Exception {
	    	// MIuWFNgStringƂēn
	    	String rmes = (String)message;
	    	LOGGER.info( "Received : " + rmes);
	    	// {̃wb_tđԂ
	    	String smes = "MINAT[oM : " + rmes;
	    	// NCAgend𑗐MĂ
	    	if( rmes.trim().startsWith("end") ) {
	    		session.write("endM܂");
	    		session.close(false);
	    		return;
	    	}
	    	session.write(smes);
	    }
}
