package TCPIP_Programming;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.charset.Charset;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

import org.apache.mina.core.filterchain.IoFilter.NextFilter;
import org.apache.mina.core.service.IoHandlerAdapter;
import org.apache.mina.core.session.IoEventType;
import org.apache.mina.core.session.IoSession;
import org.apache.mina.filter.codec.ProtocolCodecFilter;
import org.apache.mina.filter.codec.textline.TextLineCodecFactory;
import org.apache.mina.filter.executor.ExecutorFilter;
import org.apache.mina.filter.logging.LoggingFilter;
import org.apache.mina.transport.socket.SocketAcceptor;
import org.apache.mina.transport.socket.nio.NioSocketAcceptor;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class MesRecEventProfilerTestServer extends IoHandlerAdapter {
	// K[w
	private final static Logger LOGGER = LoggerFactory.getLogger(MesRecEventProfilerTestServer.class);
	// t|[gԍ
	private static final int PORT = 1000;
	
	public static void main(String[] args) throws IOException { 
		// ANZv^p
		SocketAcceptor acceptor = new NioSocketAcceptor();
/*		// ftHg̃K[EtB^ǉƂ́ÃRgEAEgO
		acceptor.getFilterChain().addLast("logger", new LoggingFilter()); */
		// eLXgs̃R[fbNǉ
		acceptor.getFilterChain().addLast("codec",
				new ProtocolCodecFilter(
						new TextLineCodecFactory( Charset.forName("Windows-31J"))));
						// R[hϊǉ
		// vt@CEtB^ǉ
		acceptor.getFilterChain().addLast("profiler", new MesRecEventProfilerTestFilter());
/*		acceptor.getFilterChain().addLast("profiler", new MesRecEventProfilerTestFilter
				(TimeUnit.MILLISECONDS, IoEventType.MESSAGE_RECEIVED));		//֕@	*/
		// ExecutorFilter̎
//		acceptor.getFilterChain().addLast("threadPool", new ExecutorFilter(10));
		acceptor.setReuseAddress( false );	// Kv΂trueɂ
		// Zbgnh͂̃NX̃IuWFNg
		acceptor.setHandler(new MesRecEventProfilerTestServer());
		// \PbgEAhXoChāAT[oJn
		acceptor.bind(new InetSocketAddress(PORT));
		System.out.println("MINA EchoT[oJn");
	}    

	public void messageReceived(IoSession session, Object message)
	throws Exception {
		// MIuWFNgStringƂēn
		String rmes = (String)message;
		LOGGER.info( "Received : " + rmes);
		// {̃wb_tđԂ
		String smes = "MINAT[oM : " + rmes;
		// NCAgend𑗐MĂ
		if( rmes.trim().startsWith("end") ) {
			session.write("endM܂");
			session.close(false);
			return;
		}
//		Thread.sleep(5000); // Ԃ邱Ƃ̃V~[V
		session.write(smes);
	}
	//messageSentCxg̔Ԃ𒲂ׂeXgpR[h
/*	public void messageSent(IoSession session, Object message)
	throws Exception {
		LOGGER.info("message sent"); 
		// eXgpAȂɂȂ
	} */
}
