package TCPIP_Programming;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.net.Socket;
import java.util.Calendar;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class MultiClientSimulator implements Runnable{
	// ԍtRXgN^
	int client_number;
	MultiClientSimulator(int i){
		client_number = i;
	}

	// K[ݒ
	private final static Logger LOGGER = LoggerFactory.getLogger(MultiClientSimulator.class);

	// CE\bh
	public static void main(String[] args) throws IOException { 
		int clients = 1;
		if (args.length == 1){clients = Integer.parseInt(args[0].trim());}
		// Executor̍쐬
		ExecutorService threadExecutor = Executors.newFixedThreadPool( clients );
		int i;
		for (i = 1; i <= clients; i++){
			// start threads and place in runnable state   
			threadExecutor.execute( new MultiClientSimulator(i) ); // ^XN̊Jn
//			Thread.sleep(1000);
		}
		threadExecutor.shutdown(); // [JEXbh̃Vbg_E
		LOGGER.info( "Xbh̊Jn, main͏I" );
	}

	// XbhE^XN
	public void run(){
		try{
			// T[oƐڑ
			Socket client_socket = new Socket("localhost", 1000);
			// Xg[̐
			BufferedReader downward_stream = new BufferedReader(
					new InputStreamReader(client_socket.getInputStream(), "Windows-31J"));
			PrintStream upward_stream = new PrintStream(client_socket.getOutputStream(), true, "Windows-31J");
			// ^CX^veXgsM
			upward_stream.printf("NCAgF%d@ %tTS \n", client_number, Calendar.getInstance());
			// GR[obNM
			String received_data = downward_stream.readLine();
			String arrived_time = String.format(" %tTS", Calendar.getInstance());            
			LOGGER.info( received_data + arrived_time);
			// ڑ̐ؒf
//			Thread.sleep(5000); // ڑԂ̉e𒲂ׂeXgp
			client_socket.close();
		}
		catch (Exception e){
			e.printStackTrace();
			System.exit(-1);
			return;
		}
	}
}
