package TCPIP_Programming;

import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketAddress;
import java.net.InetSocketAddress;

public class ReuseAddressTestServer {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		for (int i = 0; i < 5; i++) {
			try {
				ServerSocket ss = new ServerSocket();
				ss.setReuseAddress(false);
				ss.bind(new InetSocketAddress("localhost", 1000));
				Socket s = ss.accept();
				SocketAddress ca = s.getRemoteSocketAddress();
				System.out.printf("Connection Established: #%d", i);
				System.out.printf(", Time: %tTS \n", java.util.Calendar.getInstance());
				System.out.println("Start serving : " + ca);
				ss.close();
			} catch (Exception ex) {
				ex.printStackTrace();
				return;
			}
		}
	}
}
