package TCPIP_Programming;
import java.util.concurrent.TimeUnit;

import org.apache.mina.core.session.IoEventType;
import org.apache.mina.core.session.IoSession;
import org.apache.mina.filter.statistic.ProfilerTimerFilter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class MesRecEventProfilerTestFilter extends ProfilerTimerFilter{
	// RXgN^
	MesRecEventProfilerTestFilter(){
		super();
	}	
	// ԒPʂƃCxgw\ȃRXgN^
	MesRecEventProfilerTestFilter(TimeUnit tu, IoEventType et){
		super(tu, et);
	}
	private final static Logger LOGGER = LoggerFactory.getLogger(MesRecEventProfilerTestFilter.class);
	// messageReceived\bhI[oCh
	public void messageReceived(NextFilter nextFilter, IoSession session, Object message)
	throws Exception {
		long start = System.currentTimeMillis();
		// X[p[ENX̂̃\bhĂ
		super.messageReceived(nextFilter, session, message);
		long end = System.currentTimeMillis();
		// Ԃ~bŃO
		LOGGER.info("Received message processed in (mS) : " + 
				(end - start));		
		// ɕϏԂ~bŃO
		LOGGER.info("Averaged process time (mS) : " + 
				getAverageTime(IoEventType.MESSAGE_RECEIVED));
	}
}
