package TCPIP_Programming;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.charset.Charset;

import org.apache.mina.filter.codec.ProtocolCodecFilter;
import org.apache.mina.filter.codec.textline.TextLineCodecFactory;
import org.apache.mina.filter.logging.LoggingFilter;
import org.apache.mina.transport.socket.SocketAcceptor;
import org.apache.mina.transport.socket.nio.NioSocketAcceptor;

public class MinaEchoServer {
	// t|[gԍ
	private static final int PORT = 1000;
	
	public static void main(String[] args) throws IOException { 
		// ANZv^p
		SocketAcceptor acceptor = new NioSocketAcceptor();
		acceptor.getFilterChain().addLast("logger", new LoggingFilter()); // ftHg̃K[ǉ
		acceptor.getFilterChain().addLast("codec",
				new ProtocolCodecFilter(
						new TextLineCodecFactory( Charset.forName("Windows-31J")))); // R[hϊǉ
		acceptor.setReuseAddress( false );	// Kv΂trueɂ
		acceptor.setHandler(new AnotherEchoProtocolHandler());
		// \PbgEAhXoChāAT[oJn
		acceptor.bind(new InetSocketAddress(PORT));
		System.out.println("MINA EchoT[oJn");
		// 1ƂɃX[vbg
		for (;;) {
			System.out.println("R: " + acceptor.getStatistics().getReadBytesThroughput() + ", W: " + acceptor.getStatistics().getWrittenBytesThroughput());
			try {
				Thread.sleep(60 * 1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}
}
